fix union type names (#5902)

* fix union type names

* fix up generation and test

* format

* update codegen
This commit is contained in:
Dan Field
2020-05-13 10:26:32 -07:00
committed by GitHub
parent 32782e4ad1
commit 91399ad055
7 changed files with 103 additions and 45 deletions

View File

@@ -30,8 +30,7 @@ class CheckOtherLangaugesData {
List<int> data = await new io.File(path.join( List<int> data = await new io.File(path.join(
path.dirname(io.Platform.script.path), path.dirname(io.Platform.script.path),
'monsterdata_test.mon', 'monsterdata_test.mon',
)) )).readAsBytes();
.readAsBytes();
example.Monster mon = new example.Monster(data); example.Monster mon = new example.Monster(data);
expect(mon.hp, 80); expect(mon.hp, 80);
expect(mon.mana, 150); expect(mon.mana, 150);
@@ -58,8 +57,71 @@ class CheckOtherLangaugesData {
expect(mon.testarrayofstring[1], "test2"); expect(mon.testarrayofstring[1], "test2");
// this will fail if accessing any field fails. // this will fail if accessing any field fails.
expect(mon.toString(), expect(
'Monster{pos: Vec3{x: 1.0, y: 2.0, z: 3.0, test1: 3.0, test2: Color{value: 2}, test3: Test{a: 5, b: 6}}, mana: 150, hp: 80, name: MyMonster, inventory: [0, 1, 2, 3, 4], color: Color{value: 8}, testType: AnyTypeId{value: 1}, test: Monster{pos: null, mana: 150, hp: 100, name: Fred, inventory: null, color: Color{value: 8}, testType: AnyTypeId{value: 0}, test: null, test4: null, testarrayofstring: null, testarrayoftables: null, enemy: null, testnestedflatbuffer: null, testempty: null, testbool: false, testhashs32Fnv1: 0, testhashu32Fnv1: 0, testhashs64Fnv1: 0, testhashu64Fnv1: 0, testhashs32Fnv1a: 0, testhashu32Fnv1a: 0, testhashs64Fnv1a: 0, testhashu64Fnv1a: 0, testarrayofbools: null, testf: 3.14159, testf2: 3.0, testf3: 0.0, testarrayofstring2: null, testarrayofsortedstruct: null, flex: null, test5: null, vectorOfLongs: null, vectorOfDoubles: null, parentNamespaceTest: null, vectorOfReferrables: null, singleWeakReference: 0, vectorOfWeakReferences: null, vectorOfStrongReferrables: null, coOwningReference: 0, vectorOfCoOwningReferences: null, nonOwningReference: 0, vectorOfNonOwningReferences: null}, test4: [Test{a: 10, b: 20}, Test{a: 30, b: 40}], testarrayofstring: [test1, test2], testarrayoftables: null, enemy: Monster{pos: null, mana: 150, hp: 100, name: Fred, inventory: null, color: Color{value: 8}, testType: AnyTypeId{value: 0}, test: null, test4: null, testarrayofstring: null, testarrayoftables: null, enemy: null, testnestedflatbuffer: null, testempty: null, testbool: false, testhashs32Fnv1: 0, testhashu32Fnv1: 0, testhashs64Fnv1: 0, testhashu64Fnv1: 0, testhashs32Fnv1a: 0, testhashu32Fnv1a: 0, testhashs64Fnv1a: 0, testhashu64Fnv1a: 0, testarrayofbools: null, testf: 3.14159, testf2: 3.0, testf3: 0.0, testarrayofstring2: null, testarrayofsortedstruct: null, flex: null, test5: null, vectorOfLongs: null, vectorOfDoubles: null, parentNamespaceTest: null, vectorOfReferrables: null, singleWeakReference: 0, vectorOfWeakReferences: null, vectorOfStrongReferrables: null, coOwningReference: 0, vectorOfCoOwningReferences: null, nonOwningReference: 0, vectorOfNonOwningReferences: null}, testnestedflatbuffer: null, testempty: null, testbool: false, testhashs32Fnv1: -579221183, testhashu32Fnv1: 3715746113, testhashs64Fnv1: 7930699090847568257, testhashu64Fnv1: 7930699090847568257, testhashs32Fnv1a: -1904106383, testhashu32Fnv1a: 2390860913, testhashs64Fnv1a: 4898026182817603057, testhashu64Fnv1a: 4898026182817603057, testarrayofbools: [true, false, true], testf: 3.14159, testf2: 3.0, testf3: 0.0, testarrayofstring2: null, testarrayofsortedstruct: null, flex: null, test5: [Test{a: 10, b: 20}, Test{a: 30, b: 40}], vectorOfLongs: [1, 100, 10000, 1000000, 100000000], vectorOfDoubles: [-1.7976931348623157e+308, 0.0, 1.7976931348623157e+308], parentNamespaceTest: null, vectorOfReferrables: null, singleWeakReference: 0, vectorOfWeakReferences: null, vectorOfStrongReferrables: null, coOwningReference: 0, vectorOfCoOwningReferences: null, nonOwningReference: 0, vectorOfNonOwningReferences: null}'); mon.toString(),
'Monster{'
'pos: Vec3{x: 1.0, y: 2.0, z: 3.0, test1: 3.0, test2: Color{value: 2}, test3: Test{a: 5, b: 6}}, '
'mana: 150, hp: 80, name: MyMonster, inventory: [0, 1, 2, 3, 4], '
'color: Color{value: 8}, testType: AnyTypeId{value: 1}, '
'test: Monster{pos: null, mana: 150, hp: 100, name: Fred, '
'inventory: null, color: Color{value: 8}, testType: AnyTypeId{value: 0}, '
'test: null, test4: null, testarrayofstring: null, '
'testarrayoftables: null, enemy: null, testnestedflatbuffer: null, '
'testempty: null, testbool: false, testhashs32Fnv1: 0, '
'testhashu32Fnv1: 0, testhashs64Fnv1: 0, testhashu64Fnv1: 0, '
'testhashs32Fnv1a: 0, testhashu32Fnv1a: 0, testhashs64Fnv1a: 0, '
'testhashu64Fnv1a: 0, testarrayofbools: null, testf: 3.14159, '
'testf2: 3.0, testf3: 0.0, testarrayofstring2: null, '
'testarrayofsortedstruct: null, flex: null, test5: null, '
'vectorOfLongs: null, vectorOfDoubles: null, parentNamespaceTest: null, '
'vectorOfReferrables: null, singleWeakReference: 0, '
'vectorOfWeakReferences: null, vectorOfStrongReferrables: null, '
'coOwningReference: 0, vectorOfCoOwningReferences: null, '
'nonOwningReference: 0, vectorOfNonOwningReferences: null, '
'anyUniqueType: AnyUniqueAliasesTypeId{value: 0}, anyUnique: null, '
'anyAmbiguousType: AnyAmbiguousAliasesTypeId{value: 0}, '
'anyAmbiguous: null, vectorOfEnums: null, signedEnum: Race{value: -1}}, '
'test4: [Test{a: 10, b: 20}, Test{a: 30, b: 40}], '
'testarrayofstring: [test1, test2], testarrayoftables: null, '
'enemy: Monster{pos: null, mana: 150, hp: 100, name: Fred, '
'inventory: null, color: Color{value: 8}, testType: AnyTypeId{value: 0}, '
'test: null, test4: null, testarrayofstring: null, '
'testarrayoftables: null, enemy: null, testnestedflatbuffer: null, '
'testempty: null, testbool: false, testhashs32Fnv1: 0, '
'testhashu32Fnv1: 0, testhashs64Fnv1: 0, testhashu64Fnv1: 0, '
'testhashs32Fnv1a: 0, testhashu32Fnv1a: 0, testhashs64Fnv1a: 0, '
'testhashu64Fnv1a: 0, testarrayofbools: null, testf: 3.14159, '
'testf2: 3.0, testf3: 0.0, testarrayofstring2: null, '
'testarrayofsortedstruct: null, flex: null, test5: null, '
'vectorOfLongs: null, vectorOfDoubles: null, parentNamespaceTest: null, '
'vectorOfReferrables: null, singleWeakReference: 0, '
'vectorOfWeakReferences: null, vectorOfStrongReferrables: null, '
'coOwningReference: 0, vectorOfCoOwningReferences: null, '
'nonOwningReference: 0, vectorOfNonOwningReferences: null, '
'anyUniqueType: AnyUniqueAliasesTypeId{value: 0}, anyUnique: null, '
'anyAmbiguousType: AnyAmbiguousAliasesTypeId{value: 0}, '
'anyAmbiguous: null, vectorOfEnums: null, signedEnum: Race{value: -1}}, '
'testnestedflatbuffer: null, testempty: null, testbool: true, '
'testhashs32Fnv1: -579221183, testhashu32Fnv1: 3715746113, '
'testhashs64Fnv1: 7930699090847568257, '
'testhashu64Fnv1: 7930699090847568257, '
'testhashs32Fnv1a: -1904106383, testhashu32Fnv1a: 2390860913, '
'testhashs64Fnv1a: 4898026182817603057, '
'testhashu64Fnv1a: 4898026182817603057, '
'testarrayofbools: [true, false, true], testf: 3.14159, testf2: 3.0, '
'testf3: 0.0, testarrayofstring2: null, testarrayofsortedstruct: null, '
'flex: null, test5: [Test{a: 10, b: 20}, Test{a: 30, b: 40}], '
'vectorOfLongs: [1, 100, 10000, 1000000, 100000000], '
'vectorOfDoubles: [-1.7976931348623157e+308, 0.0, 1.7976931348623157e+308], '
'parentNamespaceTest: null, vectorOfReferrables: null, '
'singleWeakReference: 0, vectorOfWeakReferences: null, '
'vectorOfStrongReferrables: null, coOwningReference: 0, '
'vectorOfCoOwningReferences: null, nonOwningReference: 0, '
'vectorOfNonOwningReferences: null, '
'anyUniqueType: AnyUniqueAliasesTypeId{value: 0}, anyUnique: null, '
'anyAmbiguousType: AnyAmbiguousAliasesTypeId{value: 0}, '
'anyAmbiguous: null, vectorOfEnums: null, signedEnum: Race{value: -1}}',
);
} }
} }
@@ -88,7 +150,6 @@ class BuilderTest {
testBuilder.finish(30, 40); testBuilder.finish(30, 40);
final test4 = fbBuilder.endStructVector(2); final test4 = fbBuilder.endStructVector(2);
monBuilder monBuilder
..begin() ..begin()
..addPos( ..addPos(
@@ -167,8 +228,8 @@ class BuilderTest {
expect(byteData.getUint8(6), 126); // '~' expect(byteData.getUint8(6), 126); // '~'
expect(byteData.getUint8(7), 255); // 'ÿ' expect(byteData.getUint8(7), 255); // 'ÿ'
// First 4 bytes of the table data are a backwards offset to the vtable. // First 4 bytes of the table data are a backwards offset to the vtable.
int vTableLoc = tableDataLoc - int vTableLoc =
byteData.getInt32(tableDataLoc, Endian.little); tableDataLoc - byteData.getInt32(tableDataLoc, Endian.little);
// First 2 bytes of the vtable are the size of the vtable in bytes, which // First 2 bytes of the vtable are the size of the vtable in bytes, which
// should be 4. // should be 4.
expect(byteData.getUint16(vTableLoc, Endian.little), 4); expect(byteData.getUint16(vTableLoc, Endian.little), 4);
@@ -231,8 +292,8 @@ class BuilderTest {
// First 4 bytes are an offset to the table data. // First 4 bytes are an offset to the table data.
int tableDataLoc = byteData.getUint32(0, Endian.little); int tableDataLoc = byteData.getUint32(0, Endian.little);
// First 4 bytes of the table data are a backwards offset to the vtable. // First 4 bytes of the table data are a backwards offset to the vtable.
int vTableLoc = tableDataLoc - int vTableLoc =
byteData.getInt32(tableDataLoc, Endian.little); tableDataLoc - byteData.getInt32(tableDataLoc, Endian.little);
// First 2 bytes of the vtable are the size of the vtable in bytes, which // First 2 bytes of the vtable are the size of the vtable in bytes, which
// should be 10. // should be 10.
expect(byteData.getUint16(vTableLoc, Endian.little), 10); expect(byteData.getUint16(vTableLoc, Endian.little), 10);
@@ -242,10 +303,9 @@ class BuilderTest {
// Remaining 6 bytes are the offsets within the object where the ints are // Remaining 6 bytes are the offsets within the object where the ints are
// located. // located.
for (int i = 0; i < 3; i++) { for (int i = 0; i < 3; i++) {
int offset = int offset = byteData.getUint16(vTableLoc + 4 + 2 * i, Endian.little);
byteData.getUint16(vTableLoc + 4 + 2 * i, Endian.little); expect(
expect(byteData.getInt32(tableDataLoc + offset, Endian.little), byteData.getInt32(tableDataLoc + offset, Endian.little), 10 + 10 * i);
10 + 10 * i);
} }
} }

View File

@@ -6,8 +6,6 @@ library my_game.example2;
import 'dart:typed_data' show Uint8List; import 'dart:typed_data' show Uint8List;
import 'package:flat_buffers/flat_buffers.dart' as fb; import 'package:flat_buffers/flat_buffers.dart' as fb;
import 'include_test1_my_game.example2_generated.dart';
import 'include_test2_my_game.example2_generated.dart';
import './monster_test_my_game_generated.dart' as my_game; import './monster_test_my_game_generated.dart' as my_game;
import './monster_test_my_game.example_generated.dart' as my_game_example; import './monster_test_my_game.example_generated.dart' as my_game_example;

View File

@@ -6,8 +6,6 @@ library my_game.example;
import 'dart:typed_data' show Uint8List; import 'dart:typed_data' show Uint8List;
import 'package:flat_buffers/flat_buffers.dart' as fb; import 'package:flat_buffers/flat_buffers.dart' as fb;
import 'include_test1_my_game.example_generated.dart';
import 'include_test2_my_game.example_generated.dart';
import './monster_test_my_game_generated.dart' as my_game; import './monster_test_my_game_generated.dart' as my_game;
import './monster_test_my_game.example2_generated.dart' as my_game_example2; import './monster_test_my_game.example2_generated.dart' as my_game_example2;
@@ -719,7 +717,7 @@ class ReferrableObjectBuilder extends fb.ObjectBuilder {
return fbBuilder.finish(offset, fileIdentifier); return fbBuilder.finish(offset, fileIdentifier);
} }
} }
/// an example documentation comment: monster object /// an example documentation comment: "monster object"
class Monster { class Monster {
Monster._(this._bc, this._bcOffset); Monster._(this._bc, this._bcOffset);
factory Monster(List<int> bytes) { factory Monster(List<int> bytes) {
@@ -786,18 +784,18 @@ class Monster {
AnyUniqueAliasesTypeId get anyUniqueType => new AnyUniqueAliasesTypeId.fromValue(const fb.Uint8Reader().vTableGet(_bc, _bcOffset, 90, 0)); AnyUniqueAliasesTypeId get anyUniqueType => new AnyUniqueAliasesTypeId.fromValue(const fb.Uint8Reader().vTableGet(_bc, _bcOffset, 90, 0));
dynamic get anyUnique { dynamic get anyUnique {
switch (anyUniqueType?.value) { switch (anyUniqueType?.value) {
case 1: return M.reader.vTableGet(_bc, _bcOffset, 92, null); case 1: return Monster.reader.vTableGet(_bc, _bcOffset, 92, null);
case 2: return TS.reader.vTableGet(_bc, _bcOffset, 92, null); case 2: return TestSimpleTableWithEnum.reader.vTableGet(_bc, _bcOffset, 92, null);
case 3: return M2.reader.vTableGet(_bc, _bcOffset, 92, null); case 3: return my_game_example2.Monster.reader.vTableGet(_bc, _bcOffset, 92, null);
default: return null; default: return null;
} }
} }
AnyAmbiguousAliasesTypeId get anyAmbiguousType => new AnyAmbiguousAliasesTypeId.fromValue(const fb.Uint8Reader().vTableGet(_bc, _bcOffset, 94, 0)); AnyAmbiguousAliasesTypeId get anyAmbiguousType => new AnyAmbiguousAliasesTypeId.fromValue(const fb.Uint8Reader().vTableGet(_bc, _bcOffset, 94, 0));
dynamic get anyAmbiguous { dynamic get anyAmbiguous {
switch (anyAmbiguousType?.value) { switch (anyAmbiguousType?.value) {
case 1: return M1.reader.vTableGet(_bc, _bcOffset, 96, null); case 1: return Monster.reader.vTableGet(_bc, _bcOffset, 96, null);
case 2: return M2.reader.vTableGet(_bc, _bcOffset, 96, null); case 2: return Monster.reader.vTableGet(_bc, _bcOffset, 96, null);
case 3: return M3.reader.vTableGet(_bc, _bcOffset, 96, null); case 3: return Monster.reader.vTableGet(_bc, _bcOffset, 96, null);
default: return null; default: return null;
} }
} }

View File

@@ -6,8 +6,6 @@ library my_game;
import 'dart:typed_data' show Uint8List; import 'dart:typed_data' show Uint8List;
import 'package:flat_buffers/flat_buffers.dart' as fb; import 'package:flat_buffers/flat_buffers.dart' as fb;
import 'include_test1_my_game_generated.dart';
import 'include_test2_my_game_generated.dart';
import './monster_test_my_game.example_generated.dart' as my_game_example; import './monster_test_my_game.example_generated.dart' as my_game_example;
import './monster_test_my_game.example2_generated.dart' as my_game_example2; import './monster_test_my_game.example2_generated.dart' as my_game_example2;

View File

@@ -473,17 +473,20 @@ class DartGenerator : public BaseGenerator {
(*namespace_code)[object_namespace] += code; (*namespace_code)[object_namespace] += code;
} }
std::string NamespaceAliasFromUnionType(const std::string &in) { std::string NamespaceAliasFromUnionType(Namespace *root_namespace,
if (in.find('_') == std::string::npos) { return in; } const Type &type) {
const std::vector<std::string> qualified_name_parts =
type.struct_def->defined_namespace->components;
if (std::equal(root_namespace->components.begin(),
root_namespace->components.end(),
qualified_name_parts.begin())) {
return type.struct_def->name;
}
std::stringstream ss(in);
std::string item;
std::vector<std::string> parts;
std::string ns; std::string ns;
while (std::getline(ss, item, '_')) { parts.push_back(item); } for (auto it = qualified_name_parts.begin();
it != qualified_name_parts.end(); ++it) {
for (auto it = parts.begin(); it != parts.end() - 1; ++it) {
auto &part = *it; auto &part = *it;
for (size_t i = 0; i < part.length(); i++) { for (size_t i = 0; i < part.length(); i++) {
@@ -495,10 +498,10 @@ class DartGenerator : public BaseGenerator {
ns += static_cast<char>(tolower(part[i])); ns += static_cast<char>(tolower(part[i]));
} }
} }
if (it != parts.end() - 2) { ns += "_"; } if (it != qualified_name_parts.end() - 1) { ns += "_"; }
} }
return ns + "." + parts.back(); return ns + "." + type.struct_def->name;
} }
void GenImplementationGetters( void GenImplementationGetters(
@@ -527,7 +530,8 @@ class DartGenerator : public BaseGenerator {
en_it != enum_def.Vals().end(); ++en_it) { en_it != enum_def.Vals().end(); ++en_it) {
auto &ev = **en_it; auto &ev = **en_it;
auto enum_name = NamespaceAliasFromUnionType(ev.name); auto enum_name = NamespaceAliasFromUnionType(
enum_def.defined_namespace, ev.union_type);
code += " case " + enum_def.ToString(ev) + ": return " + code += " case " + enum_def.ToString(ev) + ": return " +
enum_name + ".reader.vTableGet(_bc, _bcOffset, " + enum_name + ".reader.vTableGet(_bc, _bcOffset, " +
NumToString(field.value.offset) + ", null);\n"; NumToString(field.value.offset) + ", null);\n";

View File

@@ -18,9 +18,9 @@ pushd "$(dirname $0)" >/dev/null
command -v pub >/dev/null 2>&1 || { echo >&2 "Dart tests require `pub` but it's not installed. Aborting."; exit 1; } command -v pub >/dev/null 2>&1 || { echo >&2 "Dart tests require `pub` but it's not installed. Aborting."; exit 1; }
command -v dart >/dev/null 2>&1 || { echo >&2 "Dart tests require dart to be in path but it's not installed. Aborting."; exit 1; } command -v dart >/dev/null 2>&1 || { echo >&2 "Dart tests require dart to be in path but it's not installed. Aborting."; exit 1; }
# output required files to the dart folder so that pub will be able to # output required files to the dart folder so that pub will be able to
# distribute them and more people can more easily run the dart tests # distribute them and more people can more easily run the dart tests
../flatc --dart -I include_test -o ../dart/test monster_test.fbs ../flatc --dart --no-includes -I include_test -o ../dart/test monster_test.fbs
cp monsterdata_test.mon ../dart/test cp monsterdata_test.mon ../dart/test
cd ../dart cd ../dart

View File

@@ -784,18 +784,18 @@ class Monster {
AnyUniqueAliasesTypeId get anyUniqueType => new AnyUniqueAliasesTypeId.fromValue(const fb.Uint8Reader().vTableGet(_bc, _bcOffset, 90, 0)); AnyUniqueAliasesTypeId get anyUniqueType => new AnyUniqueAliasesTypeId.fromValue(const fb.Uint8Reader().vTableGet(_bc, _bcOffset, 90, 0));
dynamic get anyUnique { dynamic get anyUnique {
switch (anyUniqueType?.value) { switch (anyUniqueType?.value) {
case 1: return M.reader.vTableGet(_bc, _bcOffset, 92, null); case 1: return Monster.reader.vTableGet(_bc, _bcOffset, 92, null);
case 2: return TS.reader.vTableGet(_bc, _bcOffset, 92, null); case 2: return TestSimpleTableWithEnum.reader.vTableGet(_bc, _bcOffset, 92, null);
case 3: return M2.reader.vTableGet(_bc, _bcOffset, 92, null); case 3: return my_game_example2.Monster.reader.vTableGet(_bc, _bcOffset, 92, null);
default: return null; default: return null;
} }
} }
AnyAmbiguousAliasesTypeId get anyAmbiguousType => new AnyAmbiguousAliasesTypeId.fromValue(const fb.Uint8Reader().vTableGet(_bc, _bcOffset, 94, 0)); AnyAmbiguousAliasesTypeId get anyAmbiguousType => new AnyAmbiguousAliasesTypeId.fromValue(const fb.Uint8Reader().vTableGet(_bc, _bcOffset, 94, 0));
dynamic get anyAmbiguous { dynamic get anyAmbiguous {
switch (anyAmbiguousType?.value) { switch (anyAmbiguousType?.value) {
case 1: return M1.reader.vTableGet(_bc, _bcOffset, 96, null); case 1: return Monster.reader.vTableGet(_bc, _bcOffset, 96, null);
case 2: return M2.reader.vTableGet(_bc, _bcOffset, 96, null); case 2: return Monster.reader.vTableGet(_bc, _bcOffset, 96, null);
case 3: return M3.reader.vTableGet(_bc, _bcOffset, 96, null); case 3: return Monster.reader.vTableGet(_bc, _bcOffset, 96, null);
default: return null; default: return null;
} }
} }